/*=====================================================================
 
 QGroundControl Open Source Ground Control Station
 
 (c) 2009 - 2014 QGROUNDCONTROL PROJECT <http://www.qgroundcontrol.org>
 
 This file is part of the QGROUNDCONTROL project
 
 QGROUNDCONTROL is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 QGROUNDCONTROL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with QGROUNDCONTROL. If not, see <http://www.gnu.org/licenses/>.
 
 ======================================================================*/

#ifndef GenericParameterFacts_h
#define GenericParameterFacts_h

#include <QObject>

#include "ParameterLoader.h"
#include "UASInterface.h"
#include "AutoPilotPlugin.h"

/// @file
///     @author Don Gagne <don@thegagnes.com>

/// Collection of Parameter Facts for Generic AutoPilot

class GenericParameterFacts : public ParameterLoader
{
    Q_OBJECT
    
public:
    /// @param uas Uas which this set of facts is associated with
    GenericParameterFacts(AutoPilotPlugin* autopilot, Vehicle* vehicle, QObject* parent = NULL);
    
    /// Override from ParameterLoader
    virtual QString getDefaultComponentIdParam(void) const { return QString(); }
};

#endif